function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);

	//LD-8267 - Added a condition to avoid tracking null/empty data unnecessarily
	if (hexString.length > 0 || (myTop.suspendDataCache && myTop.suspendDataCache.indexOf('VarTrivBtnTracking') >= 0) || !this.VarTrivBtnTracking.bSCORM)
		this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'inside_corporate_finance', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:655155,v:'normalState'},{id:47849,v:'normalState'},{id:50838,v:'normalState'},{id:50845,v:'normalState'},{id:50852,v:'normalState'},{id:50859,v:'normalState'},{id:265103,v:'normalState'},{id:52029,v:'normalState'},{id:58646,v:'normalState'},{id:598617,v:'normalState'},{id:176645,v:'normalState'},{id:293612,v:'normalState'},{id:9201,v:'normalState'},{id:9947,v:'normalState'},{id:575907,v:'normalState'},{id:792169,v:'normalState'},{id:792160,v:'normalState'},{id:1155532,v:'normalState'},{id:1155542,v:'normalState'},{id:1155552,v:'normalState'},{id:1155573,v:'normalState'},{id:1155588,v:'normalState'},{id:1155596,v:'normalState'},{id:1155610,v:'normalState'},{id:720758,v:'normalState'},{id:720746,v:'normalState'},{id:720722,v:'normalState'},{id:720710,v:'normalState'},{id:720698,v:'normalState'},{id:802069,v:'normalState'},{id:1234680,v:'normalState'},{id:1234691,v:'normalState'},{id:1234702,v:'normalState'},{id:1234717,v:'normalState'},{id:1234731,v:'normalState'},{id:1234745,v:'normalState'},{id:1240576,v:'normalState'},{id:1158371,v:'normalState'},{id:1243907,v:'normalState'},{id:1156962,v:'normalState'},{id:1157006,v:'normalState'},{id:1248270,v:'normalState'},{id:1157688,v:'normalState'},{id:1157696,v:'normalState'},{id:1157704,v:'normalState'},{id:1157712,v:'normalState'},{id:1157726,v:'normalState'},{id:1157740,v:'normalState'},{id:1157754,v:'normalState'},{id:1157768,v:'normalState'},{id:1157144,v:'normalState'},{id:1157155,v:'normalState'},{id:1157166,v:'normalState'},{id:1157182,v:'normalState'},{id:1157196,v:'normalState'},{id:1157211,v:'normalState'},{id:1260719,v:'normalState'},{id:1261325,v:'normalState'},{id:1244335,v:'normalState'},{id:1244351,v:'normalState'},{id:1267356,v:'normalState'},{id:1267369,v:'normalState'},{id:1267389,v:'normalState'},{id:1267405,v:'normalState'},{id:1270165,v:'normalState'},{id:1270178,v:'normalState'},{id:1270198,v:'normalState'},{id:1270214,v:'normalState'},{id:1273550,v:'normalState'},{id:1273562,v:'normalState'},{id:1273580,v:'normalState'},{id:1273594,v:'normalState'},{id:1274819,v:'normalState'},{id:1274832,v:'normalState'},{id:1274857,v:'normalState'},{id:1274878,v:'normalState'},{id:1244657,v:'normalState'},{id:1245076,v:'normalState'},{id:1245120,v:'normalState'},{id:1187654,v:'normalState'},{id:1187667,v:'normalState'},{id:1187680,v:'normalState'},{id:1187693,v:'normalState'},{id:1187706,v:'normalState'},{id:1282340,v:'normalState'},{id:1187723,v:'normalState'},{id:1187748,v:'normalState'},{id:1187769,v:'normalState'},{id:1187790,v:'normalState'},{id:1187799,v:'normalState'},{id:1187809,v:'normalState'},{id:1286394,v:'normalState'},{id:1286407,v:'normalState'},{id:1286420,v:'normalState'},{id:1286433,v:'normalState'},{id:1286446,v:'normalState'},{id:1286459,v:'normalState'},{id:1286476,v:'normalState'},{id:1286500,v:'normalState'},{id:1286520,v:'normalState'},{id:1286540,v:'normalState'},{id:1286549,v:'normalState'},{id:1286559,v:'normalState'},{id:1289007,v:'normalState'},{id:1289020,v:'normalState'},{id:1289033,v:'normalState'},{id:1289046,v:'normalState'},{id:1289059,v:'normalState'},{id:1289072,v:'normalState'},{id:1289089,v:'normalState'},{id:1289114,v:'normalState'},{id:1289134,v:'normalState'},{id:1289154,v:'normalState'},{id:1289163,v:'normalState'},{id:1289173,v:'normalState'},{id:1291424,v:'normalState'},{id:1291437,v:'normalState'},{id:1291450,v:'normalState'},{id:1291463,v:'normalState'},{id:1291476,v:'normalState'},{id:1291489,v:'normalState'},{id:1291506,v:'normalState'},{id:1291531,v:'normalState'},{id:1291552,v:'normalState'},{id:1291573,v:'normalState'},{id:1291582,v:'normalState'},{id:1291592,v:'normalState'},{id:1293735,v:'normalState'},{id:1293748,v:'normalState'},{id:1293761,v:'normalState'},{id:1293774,v:'normalState'},{id:1293787,v:'normalState'},{id:1293800,v:'normalState'},{id:1293817,v:'normalState'},{id:1293841,v:'normalState'},{id:1293861,v:'normalState'},{id:1293881,v:'normalState'},{id:1293890,v:'normalState'},{id:1293900,v:'normalState'},{id:1296055,v:'normalState'},{id:1296068,v:'normalState'},{id:1296081,v:'normalState'},{id:1296094,v:'normalState'},{id:1296107,v:'normalState'},{id:1296120,v:'normalState'},{id:1296137,v:'normalState'},{id:1296161,v:'normalState'},{id:1296181,v:'normalState'},{id:1296201,v:'normalState'},{id:1296210,v:'normalState'},{id:1296220,v:'normalState'},{id:937962,v:'normalState'},{id:1245314,v:'normalState'},{id:1245358,v:'normalState'},{id:1299726,v:'normalState'},{id:1300421,v:'normalState'},{id:1300730,v:'normalState'},{id:1300972,v:'normalState'},{id:1301285,v:'normalState'},{id:1245568,v:'normalState'},{id:1245582,v:'normalState'},{id:1245596,v:'normalState'},{id:1299017,v:'normalState'},{id:1299088,v:'normalState'},{id:1314679,v:'normalState'},{id:1245776,v:'normalState'},{id:1245916,v:'normalState'},{id:1244915,v:'normalState'},{id:1244941,v:'normalState'},{id:1246027,v:'normalState'},{id:1246038,v:'normalState'},{id:1246049,v:'normalState'},{id:1246064,v:'normalState'},{id:1246078,v:'normalState'},{id:1246092,v:'normalState'},{id:1160849,v:'normalState'},{id:1160893,v:'normalState'},{id:70221,v:'normalState'},{id:1055301,v:'normalState'},{id:1055315,v:'normalState'},{id:1025142,v:'normalState'},{id:1025156,v:'normalState'},{id:1025256,v:'normalState'},{id:1025270,v:'normalState'},{id:194542,v:'normalState'},{id:294732,v:'normalState'},{id:321023,v:'normalState'},{id:321015,v:'normalState'},{id:323733,v:'normalState'},{id:323725,v:'normalState'},{id:323409,v:'normalState'},{id:323401,v:'normalState'},{id:788049,v:'normalState'},{id:788063,v:'normalState'},{id:1246456,v:'normalState'},{id:923590,v:'normalState'},{id:1246226,v:'normalState'},{id:1055444,v:'normalState'},{id:70100,v:'normalState'},{id:325221,v:'normalState'},{id:325757,v:'normalState'},{id:329044,v:'normalState'},{id:327409,v:'normalState'},{id:625193,v:'normalState'},{id:625135,v:'normalState'},{id:625143,v:'normalState'},{id:625151,v:'normalState'},{id:625159,v:'normalState'},{id:625167,v:'normalState'},{id:233645,v:'normalState'},{id:233637,v:'normalState'},{id:590305,v:'normalState'},{id:590317,v:'normalState'},{id:673002,v:'normalState'},{id:674262,v:'normalState'},{id:590337,v:'normalState'},{id:590345,v:'normalState'},{id:233060,v:'normalState'},{id:233308,v:'normalState'},{id:135253,v:'normalState'},{id:234172,v:'normalState'},{id:233847,v:'normalState'},{id:233839,v:'normalState'},{id:69966,v:'normalState'}]};
